// This file is released under the 3-clause BSD license. See COPYING-BSD.
function runMe()
    toolbox_dir = get_absolute_file_path("hydraulic.sce")+"..";
    subdir=[ 'SIMM', 'Hydraulique']

    name_subpal= _("simm", "Sources")
  
    blocks=[
        "Pressure"
        "FlowVolumetric"
           ];
    xpal = xcosPal(name_subpal);
    xpal =tbx_build_pal(toolbox_dir, name_subpal, blocks, subdir, xpal);
    xcosPalAdd(xpal, subdir);

    name_subpal= _("simm", "Components")
  
    blocks=[
        "SimpleCylinder"
        "Cylinder"
        "Pump"
        "Tank"
        "Valve22"
        "Valve33"
        "Valve43"
        "Valve53"
        "PressureForceTranslator"
        "HydraulicCapacity"
        "VolEfficiency"
           ];
    xpal = xcosPal(name_subpal);
    xpal =tbx_build_pal(toolbox_dir, name_subpal, blocks, subdir, xpal);
    xcosPalAdd(xpal, subdir);

//    name_subpal= _("simm", "Parts")
//  
//    blocks=[
//        "Laminar"
//        "Turbulent"
//        "TurbulentControled"
//        "RotComp"
//        "ChamberLeft"
//        "ChamberRight"
//        "VolEfficiency"
//        "HydraulicCapacity"
//           ];
//    xpal = xcosPal(name_subpal);
//    xpal =tbx_build_pal(toolbox_dir, name_subpal, blocks, subdir, xpal);
//    xcosPalAdd(xpal, subdir);
//

    name_subpal= _("simm", "Sensors")
  
    blocks=[
        "PressureSensor"
        "FlowVolumetricSensor"
           ];
    xpal = xcosPal(name_subpal);
    xpal =tbx_build_pal(toolbox_dir, name_subpal, blocks, subdir, xpal);
    xcosPalAdd(xpal, subdir);

endfunction

runMe();
clear runMe;
