//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
function [x, y, typ] = IREP_TEMP(job, arg1, arg2)
    x = [];
    y = [];
    typ = [];
    select job
    case 'plot' then
        // deprecated
    case 'getinputs' then
        // deprecater
    case 'getoutputs' then
        // deprecated
    case 'getorigin' then
        // deprecated
    case 'set' then
        x=arg1;
        graphics=arg1.graphics;
        exprs=graphics.exprs
        model=arg1.model;

        //Choix du type de diagramme
        while (%t)  do
            [ok,tf,num_pts,grid_on,display_now,exprs] = scicos_getvalue(_("simm", 'Scope parameters'),..
            [_("simm", 'Simulation duration');_("simm", 'Number of points');_("simm", "Grid (1 yes, 0 no)");_("simm", "Live display of curves (1 yes, 0 no)")], ..
            list('vec',1,'vec',1,'vec',1,'vec', 1), ..
            exprs)
            mess=[];

            if ~ok then
                // Cancel
                break;
            end

            if num_pts <= 0
                mess=[mess ;_("simm", "Positif number of points expected")]
                ok = %f
            end

            if grid_on ~=1 & grid_on~=0
                mess=[mess ;_("simm", "Enter 1 or 0 to display/hide the grid")]
                ok = %f
            end

            if display_now ~=1 & display_now~=0
                mess=[mess ;_("simm", "Enter 1 or 0 to display curves on live/at end")]
                ok = %f
            end


            if ok then
                // Everything's ok
                model.rpar(1)=num_pts;
                model.rpar(2)=tf;
                graphics.exprs =  exprs;
                x.model=model;
                x.graphics = graphics;
                break
            else
                message(mess);
            end

        end
    case 'define' then
        tf = 100;
        num_pts = 200;
        grid_on=1;
        display_now=0;
        model=scicos_model();
        model.sim=list("IREP_TEMP_sim",99) // 99 type blocks are ignored by simulator.
        model.blocktype='c';
        model.dep_ut=[%f %f];
        model.in=[];
        model.intyp=[];
        model.out=[];
        model.outtyp=[];
        model.rpar=[num_pts,tf];
        model.opar=list("E","S")
        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=[];
        x.graphics.out_implicit=[];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=center;displayedLabel= %s;fillcolor=#FF3333"]
        x.graphics.exprs= string([tf;num_pts;grid_on;display_now])
        x.graphics.style=["blockWithLabel;verticalLabelPosition=middle;verticalAlign=center;displayedLabel=Time %s"]

    end

endfunction
